#!/usr/bin/env node
'use strict';

var app = require('cmdu');
var log = require('../lib/utils/log');
var configs = require('../lib/configs');
var config = require('../lib/utils/config');

app.language = 'zh-CN';
app.version = require('../../package.json').version;

app.describe('管理nbm版本更新检测').action(function () {
    var ignore = config.get(configs.keys.ignoreCheck);
    ignore ? log.warn('已忽略版本更新检测') : log.info('正常开启版本更新检测');
});

app.command('on').describe('开启版本更新检测').action(function () {
    config.set(configs.keys.ignoreCheck, false);
});

app.command('off').describe('关闭版本更新检测').action(function () {
    config.set(configs.keys.ignoreCheck, true);
});

app.command('force').describe('删除缓存的检测版本').action(function () {
    config.del([configs.keys.lastTimer, configs.keys.lastVersion, configs.keys.lastPublish]);
});

app.listen();