'use strict';

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _log = require('../../../lib/utils/log');

var _log2 = _interopRequireDefault(_log);

var _user = require('../../../lib/utils/user');

var _user2 = _interopRequireDefault(_user);

var _loading = require('../../../lib/utils/loading');

var _loading2 = _interopRequireDefault(_loading);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

var io = require('inquirer');

module.exports = function () {
    var _ref = _asyncToGenerator( /*#__PURE__*/_regenerator2.default.mark(function _callee(options) {
        var questions, answers, username, password, email, token;
        return _regenerator2.default.wrap(function _callee$(_context) {
            while (1) {
                switch (_context.prev = _context.next) {
                    case 0:
                        questions = [{
                            name: 'username',
                            type: 'input',
                            when: !options.username,
                            message: '请输入用户名:',
                            validate: function validate(v) {
                                return (/\w{2,}/.test(v)
                                );
                            }
                        }, {
                            name: 'password',
                            type: 'password',
                            when: !options.password,
                            message: '请输入密码:',
                            validate: function validate(v) {
                                return (/\w{2,}/.test(v)
                                );
                            }
                        }];
                        _context.next = 3;
                        return io.prompt(questions);

                    case 3:
                        answers = _context.sent;
                        username = options.username || answers.username;
                        password = options.password || answers.password;
                        email = options.email || `${username}@u51.com`;
                        token = options.token || answers.token;
                        _context.prev = 8;

                        (0, _loading2.default)('正在登录...');
                        _context.next = 12;
                        return _user2.default.login(username, password, email, token);

                    case 12:
                        _loading2.default.close();
                        _log2.default.success('登录成功。');
                        _context.next = 20;
                        break;

                    case 16:
                        _context.prev = 16;
                        _context.t0 = _context['catch'](8);

                        _loading2.default.close();
                        _log2.default.error('登录失败，请检查用户名或密码是否正确！');

                    case 20:
                    case 'end':
                        return _context.stop();
                }
            }
        }, _callee, this, [[8, 16]]);
    }));

    return function (_x) {
        return _ref.apply(this, arguments);
    };
}();