'use strict';

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

var fs = require('fs');
var path = require('path');

var config = require('../../../lib/configs');
var log = require('../../../lib/utils/log');
var helper = require('../../../lib/utils/helper');
var Package = require('../../../lib/utils/package');

module.exports = function () {
    var _ref = _asyncToGenerator( /*#__PURE__*/_regenerator2.default.mark(function _callee(packages, options) {
        var pkg, internals, result;
        return _regenerator2.default.wrap(function _callee$(_context) {
            while (1) {
                switch (_context.prev = _context.next) {
                    case 0:
                        pkg = path.resolve(process.cwd(), 'package.json');

                        if (!packages.length && fs.existsSync(pkg)) {
                            try {
                                pkg = require(pkg);
                                if (!pkg['private']) {
                                    packages = [pkg.name];
                                }
                            } catch (err) {
                                console.log('读取package.json时遇到错误: %s', err.message);
                                process.exit(1);
                            }
                        }

                        if (!packages.length) {
                            _context.next = 13;
                            break;
                        }

                        internals = [];

                        packages = packages.filter(function (name) {
                            if (helper.isInternal(name)) {
                                internals.push(name);
                                return false;
                            }
                            return true;
                        });

                        if (internals.length) {
                            log(`内部包将不会被同步: <green>${internals.join(', ')}</green>`);
                        }

                        if (!packages.length) {
                            _context.next = 11;
                            break;
                        }

                        _context.next = 9;
                        return Package.sync(packages, options);

                    case 9:
                        result = _context.sent;


                        log(`<green>Sync all packages done, successed: </green>${JSON.stringify(result.success)}, failed: ${JSON.stringify(result.failure)}`);

                    case 11:
                        _context.next = 14;
                        break;

                    case 13:
                        this.showHelp();

                    case 14:
                    case 'end':
                        return _context.stop();
                }
            }
        }, _callee, this);
    }));

    return function (_x, _x2) {
        return _ref.apply(this, arguments);
    };
}();