'use strict';

var yarn = require('../../../lib/utils/yarn');
var configs = require('../../../lib/configs');
var shell = require('../../../lib/utils/shell');

module.exports = function (packages, options) {
    var cmd;
    var args = process.argv.slice(3, 1);

    if (yarn.isUseYarn(options)) {
        cmd = configs.yarn;
        args.unshift('versions');
    } else {
        if (!/^(major|minor|patch|premajor|preminor|prepatch|prerelease|from-git)$/.test(args[0])) args = [];

        cmd = configs.npm;
        args.unshift('version');
    }

    shell.spawn(cmd, args);
};