'use strict';

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

var log = require('./log');
var config = require('./config');
var configs = require('../configs');
var request = require('./request');
var loading = require('./loading');
var semver = require('semver');

var PUSH_DURATION = 3600000; // 发布一小时之后才允许推送
var CHECK_DURATION = 21600000; // 每6小时拉一次版本

module.exports = _asyncToGenerator( /*#__PURE__*/_regenerator2.default.mark(function _callee() {
    var cmd, nbConfigs, pkg, lastCheckTimer, lastCheckVersion, lastCheckPublish, ignoreCheckUpdate, remote, lastPublish, lastVersion, localVersion;
    return _regenerator2.default.wrap(function _callee$(_context) {
        while (1) {
            switch (_context.prev = _context.next) {
                case 0:
                    cmd = 'nbm ' + process.argv.slice(2).join(' ');

                    if (!(cmd === 'nbm i -g @u51/nbm-cli')) {
                        _context.next = 3;
                        break;
                    }

                    return _context.abrupt('return');

                case 3:
                    nbConfigs = config.get();
                    pkg = require('../../../package.json');
                    lastCheckTimer = nbConfigs[configs.keys.lastTimer];
                    lastCheckVersion = nbConfigs[configs.keys.lastVersion];
                    lastCheckPublish = nbConfigs[configs.keys.lastPublish];
                    ignoreCheckUpdate = nbConfigs[configs.keys.ignoreCheck];

                    if (!ignoreCheckUpdate) {
                        _context.next = 11;
                        break;
                    }

                    return _context.abrupt('return');

                case 11:
                    if (!(!lastCheckVersion || !lastCheckPublish || !lastCheckTimer || Date.now() - lastCheckTimer > CHECK_DURATION)) {
                        _context.next = 28;
                        break;
                    }

                    _context.prev = 12;

                    loading('[%s] 正在检测脚手架最新版本...');
                    _context.next = 16;
                    return request(configs.registry + '/' + pkg.name + '/latest');

                case 16:
                    remote = _context.sent;
                    _context.next = 22;
                    break;

                case 19:
                    _context.prev = 19;
                    _context.t0 = _context['catch'](12);
                    throw new Error('请检测网络状态，或确认已连接内网。');

                case 22:
                    _context.prev = 22;

                    loading.close();
                    return _context.finish(22);

                case 25:

                    lastCheckVersion = remote.version;
                    lastCheckPublish = remote.publish_time;
                    config.set({
                        [configs.keys.lastTimer]: Date.now(),
                        [configs.keys.lastVersion]: lastCheckVersion,
                        [configs.keys.lastPublish]: lastCheckPublish
                    });

                case 28:
                    lastPublish = lastCheckPublish;
                    lastVersion = lastCheckVersion;
                    localVersion = pkg.version;

                    if (localVersion && lastVersion && lastPublish && Date.now() - lastPublish > PUSH_DURATION && semver.lt(localVersion, lastVersion)) {
                        log.warn('您的nbm-cli版本过低，请使用以下命令更新:');
                        log.info(`nbm i -g ${pkg.name}`);
                        process.exit(1);
                    }

                case 32:
                case 'end':
                    return _context.stop();
            }
        }
    }, _callee, this, [[12, 19, 22, 25]]);
}));