'use strict';

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

var log = require('./log');
var config = require('./config');
var configs = require('../configs');
var encrypt = require('./encrypt');
var request = require('./request');
var shell = require('./shell');
var Git = require('./git');
var git = Git.default;

var LOGIN_DURATION = 85680000; // 每24小时自动登录一次

exports.login = function () {
    var _ref = _asyncToGenerator( /*#__PURE__*/_regenerator2.default.mark(function _callee(username, password, email, token) {
        return _regenerator2.default.wrap(function _callee$(_context) {
            while (1) {
                switch (_context.prev = _context.next) {
                    case 0:
                        _context.next = 2;
                        return this.gitLogin(username, password, token);

                    case 2:
                        _context.next = 4;
                        return this.nbmLogin(username, password, email);

                    case 4:
                        _context.next = 6;
                        return this.iamLogin(username, password);

                    case 6:

                        config.set(configs.keys.authorization, {
                            username: encrypt.encode(username),
                            password: encrypt.encode(password),
                            email: encrypt.encode(email),
                            timer: Date.now()
                        });

                    case 7:
                    case 'end':
                        return _context.stop();
                }
            }
        }, _callee, this);
    }));

    return function (_x, _x2, _x3, _x4) {
        return _ref.apply(this, arguments);
    };
}();

exports.logout = _asyncToGenerator( /*#__PURE__*/_regenerator2.default.mark(function _callee2() {
    return _regenerator2.default.wrap(function _callee2$(_context2) {
        while (1) {
            switch (_context2.prev = _context2.next) {
                case 0:
                    _context2.next = 2;
                    return shell.exec(`npm logout --registry=${configs.registry}`, 2);

                case 2:
                    config.del([configs.keys.authorization, configs.keys.userToken, configs.keys.userInfo, configs.keys.userGit]);

                case 3:
                case 'end':
                    return _context2.stop();
            }
        }
    }, _callee2, this);
}));

/**
 * @typedef {Object} Employee
 * @property {string} Emp_No
 * @property {string} Emp_Account
 * @property {string} Emp_Mail
 * @property {string} Emp_Mobile
 * @property {string} Emp_Name
 * @property {string} Emp_Dep
 * @property {string} Emp_Status
 * @property {string} Emp_Superior
 * @property {string} Emp_CreateTime
 */

exports.iamLogin = function () {
    var _ref3 = _asyncToGenerator( /*#__PURE__*/_regenerator2.default.mark(function _callee3(username, password) {
        var args, data, user, info;
        return _regenerator2.default.wrap(function _callee3$(_context3) {
            while (1) {
                switch (_context3.prev = _context3.next) {
                    case 0:
                        args = configs.iamLogin;
                        _context3.next = 3;
                        return request.post(`${args.requestUrl}`, { username, password }, {
                            headers: {
                                Authorization: args.authorization,
                                PrivateKey: args.privateKey
                            }
                        });

                    case 3:
                        data = _context3.sent;

                        if (!(data && data.user && data.message === 'success')) {
                            _context3.next = 10;
                            break;
                        }

                        user = data.user;
                        info = {
                            Emp_No: user.work_no,
                            Emp_Account: user.account,
                            Emp_Mail: user.email,
                            Emp_Mobile: user.mobile,
                            Emp_Name: user.name,
                            Emp_Superior: user.superior,
                            Emp_Status: user.status,
                            Emp_CreateTime: user.create_time,
                            Emp_Dep: data.departmentInfoList.map(function (dep) {
                                return {
                                    id: dep.department_id,
                                    name: dep.comment
                                };
                            })
                        };


                        config.set({
                            [configs.keys.userInfo]: encrypt.encode(JSON.stringify(info))
                        });
                        _context3.next = 11;
                        break;

                    case 10:
                        throw new Error('iam登录失败');

                    case 11:
                    case 'end':
                        return _context3.stop();
                }
            }
        }, _callee3, this);
    }));

    return function (_x5, _x6) {
        return _ref3.apply(this, arguments);
    };
}();

exports.gitLogin = function () {
    var _ref4 = _asyncToGenerator( /*#__PURE__*/_regenerator2.default.mark(function _callee4(username, password) {
        var user;
        return _regenerator2.default.wrap(function _callee4$(_context4) {
            while (1) {
                switch (_context4.prev = _context4.next) {
                    case 0:
                        if (!(configs.bin !== 'fe')) {
                            _context4.next = 2;
                            break;
                        }

                        return _context4.abrupt('return');

                    case 2:
                        _context4.next = 4;
                        return git.login(username, password);

                    case 4:
                        user = _context4.sent;

                        config.set({
                            [configs.keys.userGit]: encrypt.encode(JSON.stringify(user))
                        });

                    case 6:
                    case 'end':
                        return _context4.stop();
                }
            }
        }, _callee4, this);
    }));

    return function (_x7, _x8) {
        return _ref4.apply(this, arguments);
    };
}();

exports.nbmLogin = function () {
    var _ref5 = _asyncToGenerator( /*#__PURE__*/_regenerator2.default.mark(function _callee5(username, password, email) {
        var npmConfigs;
        return _regenerator2.default.wrap(function _callee5$(_context5) {
            while (1) {
                switch (_context5.prev = _context5.next) {
                    case 0:
                        npmConfigs = {};

                        npmConfigs[`${configs.scope}/:always-auth`] = false;
                        npmConfigs[`${configs.scope}/:username`] = username;
                        npmConfigs[`${configs.scope}/:_password`] = encrypt.npmEncode(password);
                        npmConfigs[`${configs.scope}/:email`] = email;
                        config.npmSet(npmConfigs);

                    case 6:
                    case 'end':
                        return _context5.stop();
                }
            }
        }, _callee5, this);
    }));

    return function (_x9, _x10, _x11) {
        return _ref5.apply(this, arguments);
    };
}();

exports.checkLogin = _asyncToGenerator( /*#__PURE__*/_regenerator2.default.mark(function _callee6() {
    var auth, timer, username, password;
    return _regenerator2.default.wrap(function _callee6$(_context6) {
        while (1) {
            switch (_context6.prev = _context6.next) {
                case 0:
                    auth = config.get(configs.keys.authorization);

                    if (!auth || !auth.username || !auth.password || !auth.email) {
                        this.pleaseLogin();
                    }

                    timer = auth.timer || 0;
                    _context6.prev = 3;

                    if (!(Date.now() - timer > LOGIN_DURATION)) {
                        _context6.next = 9;
                        break;
                    }

                    username = encrypt.decode(auth.username);
                    password = encrypt.decode(auth.password);
                    _context6.next = 9;
                    return this.iamLogin(username, password);

                case 9:
                    return _context6.abrupt('return', true);

                case 12:
                    _context6.prev = 12;
                    _context6.t0 = _context6['catch'](3);

                    this.pleaseLogin();

                case 15:
                case 'end':
                    return _context6.stop();
            }
        }
    }, _callee6, this, [[3, 12]]);
}));

exports.pleaseLogin = function () {
    log.error(`请先登录：${configs.bin} login`);
    return process.exit(1);
};

Object.defineProperties(exports, {
    git: {
        get() {
            var user = config.get(configs.keys.userGit);
            if (user) user = JSON.parse(encrypt.decode(user));
            return user;
        }
    },
    info: {
        get() {
            var user = config.get(configs.keys.userInfo);
            if (user) user = JSON.parse(encrypt.decode(user));
            return user;
        }
    },
    isLogin: {
        get() {
            var auth = config.get(configs.keys.authorization);
            return !!(auth && auth.username && auth.password && auth.email);
        }
    }
});